[Mongo Portable](../README.md) > [BaseStore](../classes/basestore.md)



# Class: BaseStore

## Implements

* [IAbstractStore](../interfaces/iabstractstore.md)

## Index

### Methods

* [all](basestore.md#all)
* [backup](basestore.md#backup)
* [backups](basestore.md#backups)
* [createCollection](basestore.md#createcollection)
* [ensureIndex](basestore.md#ensureindex)
* [find](basestore.md#find)
* [findOne](basestore.md#findone)
* [insert](basestore.md#insert)
* [remove](basestore.md#remove)
* [removeBackup](basestore.md#removebackup)
* [restore](basestore.md#restore)
* [save](basestore.md#save)
* [update](basestore.md#update)



---
## Methods
<a id="all"></a>

###  all

► **all**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[all](../interfaces/iabstractstore.md#all)*

*Defined in [store/BaseStore.ts:18](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L18)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="backup"></a>

###  backup

► **backup**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[backup](../interfaces/iabstractstore.md#backup)*

*Defined in [store/BaseStore.ts:42](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L42)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="backups"></a>

###  backups

► **backups**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[backups](../interfaces/iabstractstore.md#backups)*

*Defined in [store/BaseStore.ts:46](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L46)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="createcollection"></a>

###  createCollection

► **createCollection**(event: *`any`*): `boolean`⎮`Promise`.<`boolean`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[createCollection](../interfaces/iabstractstore.md#createcollection)*

*Defined in [store/BaseStore.ts:6](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L6)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `boolean`⎮`Promise`.<`boolean`>





___

<a id="ensureindex"></a>

###  ensureIndex

► **ensureIndex**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[ensureIndex](../interfaces/iabstractstore.md#ensureindex)*

*Defined in [store/BaseStore.ts:38](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L38)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="find"></a>

###  find

► **find**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[find](../interfaces/iabstractstore.md#find)*

*Defined in [store/BaseStore.ts:22](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L22)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="findone"></a>

###  findOne

► **findOne**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[findOne](../interfaces/iabstractstore.md#findone)*

*Defined in [store/BaseStore.ts:26](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L26)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="insert"></a>

###  insert

► **insert**(event: *`any`*): `boolean`⎮`Promise`.<`boolean`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[insert](../interfaces/iabstractstore.md#insert)*

*Defined in [store/BaseStore.ts:10](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L10)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `boolean`⎮`Promise`.<`boolean`>





___

<a id="remove"></a>

###  remove

► **remove**(event: *`any`*): `boolean`⎮`Promise`.<`boolean`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[remove](../interfaces/iabstractstore.md#remove)*

*Defined in [store/BaseStore.ts:34](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L34)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `boolean`⎮`Promise`.<`boolean`>





___

<a id="removebackup"></a>

###  removeBackup

► **removeBackup**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[removeBackup](../interfaces/iabstractstore.md#removebackup)*

*Defined in [store/BaseStore.ts:50](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L50)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="restore"></a>

###  restore

► **restore**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[restore](../interfaces/iabstractstore.md#restore)*

*Defined in [store/BaseStore.ts:54](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L54)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="save"></a>

###  save

► **save**(event: *`any`*): `any`⎮`Promise`.<`any`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[save](../interfaces/iabstractstore.md#save)*

*Defined in [store/BaseStore.ts:14](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L14)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `any`⎮`Promise`.<`any`>





___

<a id="update"></a>

###  update

► **update**(event: *`any`*): `boolean`⎮`Promise`.<`boolean`>



*Implementation of [IAbstractStore](../interfaces/iabstractstore.md).[update](../interfaces/iabstractstore.md#update)*

*Defined in [store/BaseStore.ts:30](https://github.com/EastolfiWebDev/MongoPortable/blob/b563243/src/store/BaseStore.ts#L30)*



**Parameters:**

| Param | Type | Description |
| ------ | ------ | ------ |
| event | `any`   |  - |





**Returns:** `boolean`⎮`Promise`.<`boolean`>





___


